/*
 *      strsav.c
 *      String einlesen und speichern
 *      klin, Wed Dec 15 16:26:31 1999
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NBUF 1024

void main(void)
{
  char buf[NBUF];       /* Puffer */
  char *str;            /* String */
  int len;              /* Laenge */

  /* String in Puffer buf einlesen */
  do {
    printf("String eingeben: ");
  } while (gets(buf) == NULL || buf[0] == '\0');

  /* Stringlaenge ermitteln */
  len = strlen(buf);

  /* Speicherplatz auf Heap reservieren: len + 1 */
  if ((str = malloc(len + 1)) == NULL) {
    printf("Fehler: Kein Speicherplatz!\n");
    exit(1);
  }

  /* String von Puffer in Heap kopieren */
  strcpy(str, buf);

  /* Ausgaben */
  printf("buf: [%s] &buf=%p\n", buf, buf);
  printf("str: [%s] &str=%p\n", str, str);

} /* main() */
